      subroutine readmd(slabel, na, varcel, istep, 
     .                  nstep, xa, va, cell, vcell)
c *******************************************************************
c Reads positions, cell, velocities from SystemLabel.MD file
c generated by SIESTA.
c P. Ordejon, February 08
c ********** INPUT **************************************************
c character*60 slabel: System Label (name of MD file)
c integer na         : Number of atoms
c logical varcel     : .true. when variable cell
c integer istep      : Time step to read from MD file
c ********** OUTPUT *************************************************
c integer nstep      : Number of time steps stored in MD file
c real*8  xa(3,na)   : Atomic positions
c real*8  va(3,na)   : Velocities thereof
c real*8  cell(3,3)  : Unit cell vectors
c real*8  vcell(3,3) : Velocities thereof
c ********** BEHAVIOR ***********************************************
c This routine should be called once to initialize, and then
c sequentially for each of the time steps to read the positions,
c cell and velocities for that time step.
c 
c The first call should be for istep=0. 
c At that time, the MD file will be open and analized.
c
c Subsequent calls shoud be done for each of the time steps,
c in sequential order (istep = 1,2,3....).
c
c For each time step, the routine will return the position,
c cell and velocities for that time step.
c
c If varcel=true, it indicates that the MD file corresponds
c to a variable cell run, in which case it contains the information
c of the cell vectors and velocities (which it will return).
c If varcel=false, then the run corresponds to a fixed dell run
c and the cell vectors and velocities will not be read and returned
c because they are not contained in the MD file.
c *******************************************************************

      use precision,  only : dp

      implicit          none

      integer, parameter :: label_length = 60
      integer               na, istep, nstep
      logical               varcel
      real(dp)              cell(3,3), xa(3,na), va(3,na), vcell(3,3)
      character(len=label_length) ::  slabel

c Internal variables and arrays
      character(len=label_length+4)       :: paste
      character(len=label_length+4), save :: fnpos

      integer    ia, iu, mstep, iistep
      save       iu, mstep
      logical, save :: frstme = .true.

      real(dp), parameter :: bohr = 0.529177d0

      external          paste

c Find name of file
      fnpos = paste( slabel, '.MD' )

c Initialize stuff for initial call ....

      if (istep.eq.0) frstme=.true.

      if (frstme) then
        if (istep.ne.0) stop 'First call to readmd should have istep=0'
c Open file 
        iu=20
        open(iu,file=fnpos,form='unformatted',status='old')
        rewind iu

c Determine how many time steps are stored in MD file
        nstep=0
        mstep=0
        if (.not. varcel) then
1         read(iu,end=2)iistep
          if (iistep .ne. nstep+1) then
            write(6,'(/,a)') ' *********************'
            write(6,'(a)') ' Error reading MD file'
            write(6,'(a)') ' *********************'
            write(6,'(/,a)') 
     .       ' Probably your run is a VariableCell one, but your '
            write(6,'(a)') 
     .      ' fdf input file specifies AMD.VariableCell=.false.'
            stop
          endif
          nstep=nstep+1
          goto 1
2         continue
        else
3         read(iu,end=4)iistep, xa, va
          if (iistep .ne. nstep+1) then
            write(6,'(/,a)') ' *********************'
            write(6,'(a)') ' Error reading MD file'
            write(6,'(a)') ' *********************'
            write(6,'(/,a)') 
     .       ' Probably your run is not a VariableCell one, but your'
            write(6,'(a)') 
     .       ' fdf input file specifies AMD.VariableCell=.true.'
            stop
          endif
          read(iu,end=5)cell, vcell
          nstep=nstep+1
          goto 3
5         stop 'Incomplete MD file'
4         continue
        endif
C        write(6,'(/,a,i5,a)') 
C     .     ' Your MD file contains ',nstep,' time steps'
        rewind iu
        frstme = .false.
        goto 100
      endif

C      if (istep .gt. nstep) then stop 'istep too large in readmd'
      if (istep .gt. nstep) then 
      write(6,*) 'istep too large in readmd', istep,nstep
      stop
      endif
      if (istep .ne. mstep) stop 'wrong time step in readmd'

      read(iu,end=200) iistep, xa, va
      if ( varcel ) read(iu,end=200) cell, vcell

      ! This converts xa to Ang, and va to Ang/fs
      xa = xa * bohr
      va = va * bohr
      if (varcel) then
        cell = cell * bohr
        vcell = vcell * bohr
      endif
      
      if (istep .eq. nstep) close( iu )

100   mstep=mstep+1
      return

200   stop 'incomplete MD file'

      end




